/*
 * $Id: hedic.c,v 1.3 2002/08/08 07:10:46 halite Exp $
 *
 *  α׷  ͳ  (http://kr.alldic.yahoo.com)  ϴ.
 * halite@kldp.org
 *
 * $Log: hedic.c,v $
 * Revision 1.3  2002/08/08 07:10:46  halite
 *  syntax error 
 *
 * Revision 1.2  2002/08/08 06:51:48  halite
 * version ǥ ־
 *
 * Revision 1.1.1.1  2002/08/08 06:39:57  halite
 * ͹̳  ѿ
 *
 */

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <netdb.h>
#include <sys/socket.h>

#define VERSION	"v0.1"
#define URL		"kr.engdic.yahoo.com"
#define SURL	"http://kr.engdic.yahoo.com/result.html?p="

void parse_result(int sd)
{
	char c;
	char buf[1024];
	int i, cnt;
	int tag_start, tag_end;			// html tag ۵ǰ   Ÿϴ.
	int main_start, main_end;		//  ۵ html   شϴ ͸ main̶մϴ.
	int tail_start;					// html  κп ۱ Ÿϴ.
	int key_start;					// &lt; &gt; óϱ  ÷Դϴ.
	int no_tab;						// <div> óϱ  ÷Դϴ.

	buf[0]     = 0;
	i          = 0;
	main_start = 0;
	main_end   = 0;
	tail_start = 0;
	no_tab     = 0;
	key_start  = 0;

	printf("\n");

	//  ѱھ ޾ мմϴ.
	while (recv(sd, &c, 1, 0) != 0)
	{
		// ignore \r and \n
		if (c == '\r' || c == '\n')
			continue;

		// tag  ڴ  ҹڷ ٲ㼭 óմϴ.
		if (tag_start)
			buf[i++] = (char)tolower((int)c);
		else
			buf[i++] = c;
		buf[i] = 0;

		// main tail  óմϴ.
		if (main_start)
			goto parse_main;
		else
		if (tail_start)
			goto parse_tail;

		// search main start point
		// search tail start point
		switch (c)
		{
			case '<':
				tag_start = 1;
				tag_end   = 0;
				i         = 0;
				buf[i++]  = c;
				buf[i]    = 0;
				break;

			case '>':
				tag_start = 0;
				tag_end   = 1;
				i         = 0;

				// main  ãϴ.
				if (strcmp("<font style=\"line-height:120%\">", buf) == 0)
					main_start = 1;
				else
				// tail  ãϴ.
				if (strcmp("<hr noshade size=1>", buf) == 0)
				{
					tail_start = 1;

					printf("\n");
				}
				break;
		}
		continue;

parse_main:
		// parse main
		switch (c)
		{
			case '<':
				tag_start = 1;
				tag_end   = 0;
				i         = 0;
				buf[i++]  = c;
				buf[i]    = 0;
				break;

			case '>':
				if (strcmp("<br>", buf) == 0)
				{
					printf("\n");
					for (cnt = 0; cnt < no_tab; cnt++)
						printf("  ");
				}
				else
				// <div> óϱ  ȭ鿡 2 space ϵ մϴ.
				if (strcmp("<div>", buf) == 0)
				{
					no_tab++;
					printf("  ");
				}
				else
					// </div>  ٷ   space  ٽ space Ѵ.
				if (strcmp("</div>", buf) == 0)
				{
					no_tab--;
					printf("\r");
					for (cnt = 0; cnt < no_tab; cnt++)
						printf("  ");
				}
				else
				if (strcmp("<form name=\"search2\" onsubmit=\"return procsubmit(this);\" method=\"get\">", buf) == 0)
				{
					// stop parsing main
					main_start = 0;
					main_end   = 1;
				}

				tag_start = 0;
				tag_end   = 1;
				buf[i]    = 0;
				i         = 0;
				key_start = 0;

				break;

			case '&':
				// &lt; &gt;  ó
				if (!tag_start)
				{
					key_start = 1;
					i         = 0;
					buf[i++]  = c;
					buf[i]    = 0;
				}
				break;

			case ';':
				if (!tag_start)
				{
					if (strcmp("&lt;", buf) == 0)
						printf("<");
					else
					if (strcmp("&gt;", buf) == 0)
						printf(">");

					key_start = 0;
					i         = 0;
				}
				break;

			default:
				if (!tag_start && !key_start)
					printf("%c", c);
				break;
		}
		continue;

parse_tail:
		// parse tail
		// κп ʿ    ʰ ۱ κи ϱ  ϴ.
		switch (c)
		{
			case '<':
				tag_start = 1;
				tag_end   = 0;
				i         = 0;
				buf[i++]  = c;
				buf[i]    = 0;
				break;

			case '>':
				if (strcmp("<br>", buf) == 0)
					printf("\n");
				else
				if (strcmp("<a href=\"http://kr.docs.yahoo.com/info/disclaimer.html\">", buf) == 0)
					tail_start = 0;

				tag_start = 0;
				tag_end   = 1;
				buf[i]    = 0;
				i         = 0;

				break;

			default:
				if (!tag_start)
					printf("%c", c);
				break;
		}
	}

	printf(" α׷ Halite  ͳ  Ʈ  ϴ.\n");
	printf("ñ  halite@kldp.org...\n");
	printf("%s\n$Id: hedic.c,v 1.3 2002/08/08 07:10:46 halite Exp $\n\n", VERSION);
}

int submit(char *str)
{
	int sd;
	struct hostent *he;	
	struct sockaddr_in sai;
	char buf[1024];

	sd = socket(AF_INET, SOCK_STREAM, 0);
	if (sd < 0)
	{
		printf("Cannot make a socket.\n");
		return -1;
	}

	he = gethostbyname(URL);
	bzero((void *)&sai, sizeof(sai));
	sai.sin_family      = AF_INET;
	sai.sin_port        = htons(80);
	sai.sin_addr.s_addr = ((struct in_addr *)(he->h_addr))->s_addr;

	if (connect(sd, (void *)&sai, sizeof(sai)) < 0)
	{
		printf("Cannot connect.\n");
		close(sd);
		return -1;
	}

	// Ʈ ã ܾ ϴ.
	sprintf(buf, "GET %s%s\n", SURL, str);
	send(sd, buf, strlen(buf), 0);

	//   ִ html  ޾ мմϴ.
	parse_result(sd);

	close(sd);

	return 0;
}

int main(int argc, char *argv[])
{
	if (argc < 2)
	{
		printf("Usage : hedic word_to_find\n");
		return -1;
	}

	submit(argv[1]);

	return 0;
}

